# Advent of Code 2023

## Solution times

| Day | Name                            | Problem                                             | Parsing [µs]   | Part 1 [µs] | Part 2 [µs] | Binary Benchmark* |
|-----|---------------------------------|-----------------------------------------------------|----------------|-------------|-------------|-------------------|
| 1   | Trebuchet?!                     | Overlapping text numbers                            | (i)            | 61          | 724         | 5.9 ms ± 0.4 ms   |
| 2   | Cube Conundrum                  | Are shown cubes possible<br>Minimum number of cubes | 129            | 2           | 2           | 5.2 ms ± 1.3 ms   |
| 3   | Gear Ratios                     | Numbers located next to special characters          | (i)            | 736         | <-          | 6.6 ms ± 0.4 ms   |
| 4   | Scratchcards                    | Multiplying Scratchcards                            | 316 (+p)       | <*          | 4           | 5.5 ms ± 1.3 ms   |
| 5   | If You Give A Seed A Fertilizer | Mapping Ranges                                      | 71             | 4           | 32          | 5.3 ms ± 1.7 ms   |
| 6   | Wait For It                     | Quadratic Equation Roots                            | 2              | 99          | <*          | 5.1 ms ± 0.3 ms   |
| 7   | Camel Cards                     | Evaluating "Poker" Hands with Joker                 | 221            | 675         | 461         | 7.5 ms ± 0.7 ms   |
| 8   | Haunted Wasteland               | Ultra crafted input data cycles                     | 435            | 434         | 2062        | 9.1 ms ± 0.4 ms   |
| 9   | Mirage Maintenance              | Extrapolations                                      | 2482 (+p)      | 14          | 12          | 8.8 ms ± 1.1 ms   |
| 10  | Pipe Maze                       | Pipe following, inside area                         | 202 + 178 (+p) | 0           | 72          | 5.5 ms ± 0.3 ms   |
| 11  | Cosmic Expansion                | Distance between expanding galaxies                 | (i)            | 1924        | 1631        | 8.6 ms ± 0.6 ms   |

Legend:

- `(i)`: Integrated into parts
- `(+p)`: Parsing already includes some preparation calculations
- `<*`: Too small to measure or optimized away
- `<-`: Part 1 time includes part 2 (calculated at the same time)

*Binaries are benchmarked using `hyperfine -N --warmup 500`